<?php

App::uses('AppComponent', 'Controller/Component');

class SlideshowsComponent extends AppComponent {

/**
 * Retreives the requested slideshow and data ready to display
 *
 * @param int|string $id The unique id (or system_name) of the slideshow
 * @param array $params Additional parameters to query against
 * @return array Contains the requested slideshow and slides
 */
	public function getSlideshow($id, array $params = []) {
		$Slideshow = EvClassRegistry::init('EvSlideshow.Slideshow');

		// If the id is passed in as an int then search by id otherwise search by system_name
		if (is_int($id)) {
			$params['conditions']['Slideshow.id'] = $id;
		} else {
			$params['conditions']['Slideshow.system_name'] = $id;
		}

		$params = Hash::merge(
			[
				'conditions' => [
					'Slideshow.is_active' => true
				],
				'contain' => [
					'Slide' => [
						'conditions' => [
							'Slide.is_active' => true
						],
						'order' => [
							'Slide.sequence ASC, Slide.name ASC'
						],
						'Image'
					]
				],
			],
			$params
		);

		return $Slideshow->find('first', $params);
	}
}
